#include <bit>

#include <climits>

#include <rng.h>
#include <mem.h>

#include <rng/crand.h>
#include "crand.h"

namespace rng
{
	void crand::_deleter::delete_object(_opaque** state) { _jr_free(reinterpret_cast<jr_state*>(*state)); *state = nullptr; }

	crand::crand(_opaque* raw) :_state(mem::aligned_ptr<_opaque, _deleter>(raw)){}

	crand::crand(u64 seed) : crand(reinterpret_cast<_opaque*>(_jr_new(seed))){}
	crand::crand() : crand(0xabad1dea){}

	i64 crand::_sample_raw() { return _jr_proc(reinterpret_cast<jr_state*>(_state.get_ptr())); }

	//TODO: properly implemet this f64 crand::_sample() { return (f64)std::bit_cast<u64>(_sample_raw()) / (f64)UINT64_MAX; }

}

void rng_test()
{
	rng::crand r(123);
	printf("%lu %lu %lu\n", r.next_u64(), r.next_u64(), r.next_u64());
}
